﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DelegateAndVirtualMethods {

	delegate void MyDelegate();

	abstract class A {
		public virtual void m() {
			Console.WriteLine("A.m");
		}

		public abstract void n();
	}

	class B : A {
		public override void m() {
			Console.WriteLine("B.m");
		}

		public override void n() {
			Console.WriteLine("B.n");
		}
	}

	class Program {
		static void Main(string[] args) {
			MyDelegate md;

			A a = new B();
			md = new MyDelegate(a.m);
			md();

			md = new MyDelegate(a.n);
			md();

			// All possible because we cannot change the 'this' instance inside an existing delegete!
			// As md.this = new A() and calling md() would either call B.n on instance of A (if A is not abstract). To support such behavior much more complex (and slower) method dispatch would have to be implemented inside md().

			/**
			 
			C c = new C();
			md = new MyDelegate(c.m);
			md();

			md = new MyDelegate(((I) c).m);
			md();
			
			/**/
		}
	}

	interface I {
		void m();
	}

	class C : I {
		public virtual void m() {
			Console.WriteLine("C.m");
		}

		void I.m() {
			Console.WriteLine("C.I.m");
		}
	}
}
